Index: MochiKit/Base.js
===================================================================
--- MochiKit/Base.js	(revision 1563)
+++ MochiKit/Base.js	(working copy)
@@ -908,16 +908,21 @@
         }
         // array
         if (objtype != "function" && typeof(o.length) == "number") {
-            var res = [];
-            for (var i = 0; i < o.length; i++) {
-                var val = me(o[i]);
-                if (typeof(val) != "string") {
-                    // skip non-serializable values
-                    continue;
-                }
-                res.push(val);
-            }
-            return "[" + res.join(", ") + "]";
+        	try {
+	            var res = [];
+	            for (var i = 0; i < o.length; i++) {
+	                var val = me(o[i]);
+	                if (typeof(val) != "string") {
+	                    // skip non-serializable values
+	                    continue;
+	                }
+	                res.push(val);
+	            }
+	            return "[" + res.join(", ") + "]";
+        	} catch (e) {
+        		// do nothing, array-like serialization didn't work, try
+        		// object-like serialization. (see bug #329)
+        	}
         }
         // look in the registry
         var m = MochiKit.Base;
